diff --git a/src/backend/access/transam/xact.c b/src/backend/access/transam/xact.c
new file mode 100644
index 1495bb4..853671f
*** a/src/backend/access/transam/xact.c
--- b/src/backend/access/transam/xact.c
*************** CommitTransaction(void)
*** 1958,1963 ****
--- 1958,1966 ----
  	 */
  	s->state = TRANS_DEFAULT;
  
+ 	/* We have committed so clear any client cancel. */
+ 	QueryCancelPending = false;
+ 
  	RESUME_INTERRUPTS();
  }
  
diff --git a/src/backend/tcop/postgres.c b/src/backend/tcop/postgres.c
new file mode 100644
index 33720e8..b797cad
*** a/src/backend/tcop/postgres.c
--- b/src/backend/tcop/postgres.c
*************** exec_simple_query(const char *query_stri
*** 1165,1184 ****
  	/*
  	 * Emit duration logging if appropriate.
  	 */
- 	switch (check_log_duration(msec_str, was_logged))
  	{
! 		case 1:
! 			ereport(LOG,
! 					(errmsg("duration: %s ms", msec_str),
! 					 errhidestmt(true)));
! 			break;
! 		case 2:
! 			ereport(LOG,
! 					(errmsg("duration: %s ms  statement: %s",
! 							msec_str, query_string),
! 					 errhidestmt(true),
! 					 errdetail_execute(parsetree_list)));
! 			break;
  	}
  
  	if (save_log_statement_stats)
--- 1165,1194 ----
  	/*
  	 * Emit duration logging if appropriate.
  	 */
  	{
! 		int output_duration_level = check_log_duration(msec_str, was_logged);
! 
! 		if (output_duration_level != 0)
! 		{
! 			/* hold client cancel as we have already committed */
! 			HOLD_CANCEL_INTERRUPTS();
! 
! 			if (output_duration_level == 1)
! 				ereport(LOG,
! 						(errmsg("duration: %s ms", msec_str),
! 						 errhidestmt(true)));
! 			else if (output_duration_level == 2)
! 				ereport(LOG,
! 						(errmsg("duration: %s ms  statement: %s",
! 								msec_str, query_string),
! 						 errhidestmt(true),
! 						 errdetail_execute(parsetree_list)));
! 
! 			/* clear client cancel */
! 			QueryCancelPending = false;
! 
! 			RESUME_CANCEL_INTERRUPTS();
! 		}
  	}
  
  	if (save_log_statement_stats)
